//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--           --
//- :          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//----------------    RX_Buffer --------------------------
// : 256  = 8  * 32   
//   
// 0xd -     =      
// 0xa -     (   -   )
//   0xd 0xa -  
//      -  
//------------------------------------------------------------------------------

#ifndef __drive_h
#define __drive_h

//#include "M95_Types.h"
#include "stm32f10x.h"
#include "M95_Variables.h"
#include "M95_Strings.h"

ErrorStatus Compare_Rx_Buffer(Message_TypeDef* B);
void Copy_Rx_Buffer (Message_TypeDef* B);
void Copy_Rx_Nomber (Message_TypeDef* B);
void ClearString(uint16_t addr);
void CopyString(Message_TypeDef* A, Message_TypeDef* B);
void Built_Test(Message_TypeDef* A, Message_TypeDef* B);
void Built_Read(Message_TypeDef* A, Message_TypeDef* B);
void Built_Write(Message_TypeDef* A, Message_TypeDef* B, Message_TypeDef* C);
void Built_Execute(Message_TypeDef* A, Message_TypeDef* B);
void Built_Message (Message_TypeDef* A, Message_TypeDef* B);
void Built_Answer (Message_TypeDef* A, Message_TypeDef* B);
void ProcessMashine(void);
void State_Mishine_Copy(uint8_t NewState);          //    (     )

//  
extern void Usart_Tx(uint32_t String, uint16_t Len);
extern void SYSTIC_Start (uint32_t Value);
extern void SYSTIC_Stop (void);

//  
void Echo_Ok (void);

//  :
extern State_Mashine_TypeDef8 const STARTING_Stage;
extern State_Mashine_TypeDef2 const Wait_CallReady_Stage;
extern State_Mashine_TypeDef2 const Ready_To_Use_Stage;
extern State_Mashine_TypeDef2 const Terminate_Connection_Stage;
extern State_Mashine_TypeDef2 const Detect_Nomber_Stage;
//    (          )
static void* const Stages[8] = {(void*)&STARTING_Stage, (void*)&Wait_CallReady_Stage, (void*)&STARTING_Stage, (void*)&Ready_To_Use_Stage,
        (void*)&Terminate_Connection_Stage, (void*)&STARTING_Stage, (void*)&STARTING_Stage, (void*)&Detect_Nomber_Stage};

#endif  // __drive_h

//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F0XXX ------------------
//---------------     -------------------
//---------------          http://www.promelec.ru/           -------------------
//--------------------------           2013         ----------------------------
//------------------------------------------------------------------------------