//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--           --
//- :          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//--------------------    ----------------------------
//------------------   M95   ---------------------------
//------------------------------------------------------------------------------

#include "stm32f10x.h"
#include "M95_hard.h"
#include "M95_Variables.h"

void M95_Init(void)
//   ,   M95
//  
{
uint32_t I;  
//  
NVIC_PriorityGroupConfig(NVIC_PriorityGroup_3);

PWR_Key_Config();
Usart_DMA_Config();
Usart_Config();

for (I=0; I<SMALL_WaitTime; I++);
}



void Usart_DMA_Config(void)
{
//   /   USART1
DMA_InitTypeDef  DMA_InitStructure;
// ,    
NVIC_InitTypeDef NVIC_InitStructure;
//  
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
//  
    DMA_DeInit(DMA1_Channel4);
    DMA_InitStructure.DMA_PeripheralBaseAddr = USARTx_TDR_ADDRESS;
    DMA_InitStructure.DMA_BufferSize = (uint16_t)2;
    DMA_InitStructure.DMA_MemoryBaseAddr = 0;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;
    DMA_InitStructure.DMA_Priority = DMA_Priority_Low;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal ;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte; 
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init(DMA1_Channel4, &DMA_InitStructure);
//      
DMA_ITConfig(DMA1_Channel4, DMA_IT_TC, ENABLE);

//  
    DMA_DeInit(DMA1_Channel5);
    DMA_InitStructure.DMA_PeripheralBaseAddr = USARTx_RDR_ADDRESS;
    DMA_InitStructure.DMA_BufferSize = (uint16_t)2;
    DMA_InitStructure.DMA_MemoryBaseAddr = 0;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
    DMA_InitStructure.DMA_Priority = DMA_Priority_Low;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte; 
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init(DMA1_Channel5, &DMA_InitStructure);
//      
//DMA_ITConfig(DMA1_Channel5, DMA_IT_TC, ENABLE);
 
//      DMA (     USART)
  NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel4_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
    
}

void Usart_Tx(uint32_t String, uint16_t Len)
{
//       
//     
while (USART_TX_Buzy_FLAG==1);

//     
USART_TX_Buzy_FLAG = 1;

  //  DMA -  
  DMA_Cmd(DMA1_Channel4, DISABLE);
  
  DMA1_Channel4->CNDTR = Len;
  DMA1_Channel4->CMAR = (uint32_t)String;

  DMA_Cmd(DMA1_Channel4, ENABLE);
}

void Usart_Rx(uint32_t String, uint16_t Len)
{
//       
  //  DMA -  
  DMA_Cmd(DMA1_Channel5, DISABLE);
  
  DMA1_Channel5->CNDTR = Len;
  DMA1_Channel5->CMAR = (uint32_t)String;

  DMA_Cmd(DMA1_Channel5, ENABLE);
}

void Usart_Config(void)
{ 
// ,   usart,    
  USART_InitTypeDef USART_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure; 
  NVIC_InitTypeDef NVIC_InitStructure;

//    
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA , ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO , ENABLE);
  
//   USART1
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
  
//   9 10  USART1
//    -
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure); 
//    
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOA, &GPIO_InitStructure); 
  
//  USART1
  USART_DeInit(USART1);
  USART_InitStructure.USART_BaudRate = 9600;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(USART1, &USART_InitStructure);

//   DMA
  USART_DMACmd(USART1, USART_DMAReq_Rx, ENABLE);
  USART_DMACmd(USART1, USART_DMAReq_Tx, ENABLE);

//     
  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  USART_Cmd(USART1, ENABLE);
  
  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
}

void PWR_Key_Config(void)
{
//   =      

// ,   
  GPIO_InitTypeDef GPIO_InitStructure;

  //  
  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB, ENABLE);  

  GPIOB->ODR = GPIO_Pin_5 | GPIO_Pin_6 ; //  "1"  
  
  //  
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_5 | GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);  
  
  //  
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING ;
  GPIO_Init(GPIOB, &GPIO_InitStructure);  
}


void DMA1_Channel4_IRQHandler(void)
{
// USART /    
  if (DMA_GetITStatus(DMA1_IT_GL4)==SET)
  {
  //  
  //   DMA
  DMA_Cmd(DMA1_Channel4, DISABLE);
  //   
  DMA_ClearITPendingBit(DMA1_IT_GL4 | DMA1_IT_TC4);
  //   " "
  USART_TX_Buzy_FLAG = 0;
  //Condition_Flag=0;
  }
}

void USART1_IRQHandler(void)
{
//   -     0xa (  -  )
//  -   (  )
uint8_t I;

I=USART_ReceiveData(USART1);
if (I==0xa)
{
//    
SYSTIC_Stop();
//  " "
Condition_Flag=0;

  //     
  STOP_RX_Pointer = RX_Buffer_Size - DMA1_Channel5->CNDTR;
//   (     )
  ProcessMashine();
}
}

void SYSTIC_Start (uint32_t Value)
{
  SysTick->LOAD  = Value;                                       //   
  NVIC_SetPriority (SysTick_IRQn, (1<<__NVIC_PRIO_BITS) - 1);   //  
  SysTick->VAL   = Value;                                       //   
  SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |                 //   ,    -  
                   SysTick_CTRL_TICKINT_Msk   |
                   SysTick_CTRL_ENABLE_Msk;   
}

void SYSTIC_Stop (void)
{
  SysTick->CTRL  = 0;                  //   ,    -  
}


void SysTick_Handler(void)
{
//    
//  
USART_TX_Buzy_FLAG = 0;
Usart_Tx((uint32_t) Building_String_TX.TEXT, Building_String_TX.LEN);
}


//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--------------------------           2013         ----------------------------
//------------------------------------------------------------------------------