//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--           --
//- :          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//------------- :      ----------------
//------------------------------------------------------------------------------

#include "stm32f10x.h"
#include "M95_Variables.h"
#include "M95_Strings.h"

extern void Usart_Tx(uint32_t String, uint16_t Len);
extern void SYSTIC_Start (uint32_t Value);
extern void SYSTIC_Stop (void);

extern void Copy_Rx_Nomber (Message_TypeDef* B);
extern ErrorStatus Compare_Rx_Buffer(Message_TypeDef* B);
extern void Built_Execute(Message_TypeDef* A, Message_TypeDef* B);
extern void State_Mishine_Copy(uint8_t NewState);          //    (     )

// ,      
extern void Echo_Ok (void);
extern void Terminate_Connection_Enter (void);
void Detect_Nomber_Enter (void);
void Detect_Nomber_Ok (void);
void Continue_Ring (void);

extern void Set_POWER (void);
extern void Set_Detection (void);

uint8_t Nomber_of_rings;

//    
State_Mashine_TypeDef3 const Detect_Nomber_Stage = {3, (void*) &Building_String_TX, (void*) &message_Plus_CLIP, (void*) &message_NO_CARRIER,
                                                      (void*) &Echo_Ok, (void*) &Detect_Nomber_Ok, (void*) &Continue_Ring};

void Detect_Nomber_Enter (void)
{
//            
SYSTIC_Stop();
State=7;  
State_Mishine_Copy(State);  

//   
Built_Execute(&Building_String_TX, &message_CLIP);

Condition_Flag=1;
Echo_Correct_Flag = 1;
Nomber_of_rings=0;

Usart_Tx((uint32_t) Building_String_TX.TEXT, Building_String_TX.LEN);

SYSTIC_Start(WaitTime);
}

void Detect_Nomber_Ok (void)
{
SYSTIC_Stop();
if (Prime_Nomber_Flag==0)
{
  Prime_Nomber_Flag = 1;
  Prime_Nomber_Mess.LEN=0;
  Copy_Rx_Nomber(&Prime_Nomber_Mess);
  //  " "
  Set_Detection();
  //    
  Terminate_Connection_Enter();
}
else
{
  //   
  if (Compare_Rx_Buffer(&Prime_Nomber_Mess)==SUCCESS)
  {
    if (Nomber_of_rings==0) 
    {
      Set_POWER();
    }
    else
    {
      Nomber_of_rings--;
      if ((Nomber_of_rings==0)||(Nomber_of_rings>5)) Terminate_Connection_Enter();
    }
  }
  //    
  else
  {  //    
  Terminate_Connection_Enter();
  }
}

}

void Continue_Ring (void)
{
//    
  Terminate_Connection_Enter();
}

//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--------------------------           2013         ----------------------------
//------------------------------------------------------------------------------