//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--           --
//- :          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//----------------- :       -----------------
//------------------------------------------------------------------------------

//#include "M95_Types.h"
#include "stm32f10x.h"
#include "M95_Variables.h"
#include "M95_Strings.h"

extern void Built_Read(Message_TypeDef* A, Message_TypeDef* B);
extern void Usart_Tx(uint32_t String, uint16_t Len);
extern void Usart_Rx(uint32_t String, uint16_t Len);
extern void SYSTIC_Start (uint32_t Value);
extern void SYSTIC_Stop (void);

extern void Built_Write(Message_TypeDef* A, Message_TypeDef* B, Message_TypeDef* C);
extern void State_Mishine_Copy(uint8_t NewState);          //    (     )

void Check_CPIN (void);

extern void Echo_Ok (void);
void _No_SIM_Need (void);
void _SIM_PIN_Need (void);
void _SIM_PUK_Need (void);
void _SIM_Other_Need (void);
void _ERROR_CODE (void);
void _SIM_OK_CODE (void);

//     :
//  SIM PUK 
const Message_TypeDef message18={14, "+CPIN: SIM PUK"};
//  PH_SIM PUK 
const Message_TypeDef message19={17, "+CPIN: PH_SIM PUK"};
//  PH_SIM PIN 
const Message_TypeDef message20={17, "+CPIN: PH_SIM PIN"};
// ,    SIM 
const Message_TypeDef message21={14, "+CPIN: SIM PIN"};

//  
State_Mashine_TypeDef8 const STARTING_Stage = {8, &Building_String_TX, (void*)&message21, &message_ERROR, &message_CPIN_READY, (void*)&message18, (void*)&message19, (void*)&message20, &message_OK,
                                                      (void*) &Echo_Ok, (void*)&_SIM_PIN_Need, (void*)&_ERROR_CODE, (void*)&_No_SIM_Need, (void*)&_SIM_PUK_Need, (void*)&_SIM_Other_Need, (void*)&_SIM_Other_Need, (void*)&_SIM_OK_CODE};


void Check_CPIN (void)
{
//      
//  
Usart_Rx((uint32_t)& RX_Buffer, RX_Buffer_Size);

//  
Call_Ready_Flag=0;

State=0;
State_Mishine_Copy(State);

//     "    ?"
Built_Read(&Building_String_TX, &message_CPIN);

// ,    
Condition_Flag=1;

Echo_Correct_Flag = 1;
Usart_Tx((uint32_t) Building_String_TX.TEXT, Building_String_TX.LEN);

SYSTIC_Start(WaitTime);
while (State!=1){}
}

void _No_SIM_Need (void)
{
//   "   "
SYSTIC_Stop();                                                        // 
//     
State=1;
State_Mishine_Copy(State);
}

void _SIM_PIN_Need (void)
{
//   "  "
SYSTIC_Stop();                                                        // 
while (1) {}
}

void _SIM_PUK_Need (void)
{
//   "  "
SYSTIC_Stop();                                                        // 
while (1) {}
}

void _SIM_Other_Need (void)
{
//   "  "
SYSTIC_Stop();                                                        // 
while (1) {}
}

void _ERROR_CODE (void)
{
//   "ERROR"
SYSTIC_Stop();                                                        // 
//    ???
if (Echo_Correct_Flag==0)
{
  
}
else
{
  //   
  //  
  SYSTIC_Start(WaitTime);                                               //     
  Usart_Tx((uint32_t) Building_String_TX.TEXT, Building_String_TX.LEN);
}

}

void _SIM_OK_CODE (void)
{
//   "OK"
SYSTIC_Stop();                                                        // 
//     
}




//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--------------------------           2013         ----------------------------
//------------------------------------------------------------------------------