//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--           --
//- :          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//---------- :     "Call Ready" ------------------
//----------        -----------------------
//------------------------------------------------------------------------------

//#include "M95_Types.h"
#include "stm32f10x.h"
#include "M95_Variables.h"
#include "M95_Strings.h"

extern void Usart_Tx(uint32_t String, uint16_t Len);
extern void SYSTIC_Start (uint32_t Value);
extern void SYSTIC_Stop (void);

extern void Built_Read(Message_TypeDef* A, Message_TypeDef* B);
extern void Built_Write(Message_TypeDef* A, Message_TypeDef* B, Message_TypeDef* C);
extern void State_Mishine_Copy(uint8_t NewState);          //    (     )

uint8_t Net_Registration_Flag;
char First_Nomber;
char Second_Nomber;

void Wait_Net_Registration (void);
// ,      
extern void Echo_Ok (void);
void Call_Ready (void);
void Reg_Reques_Answer(void);
void Digit_ZERO(void);
void Digit_ONE(void);
void Digit_Five(void);
void Restart_Wait(void);

//  
const Message_TypeDef message_CALL_READY={10, "CALL READY"};
const Message_TypeDef message_Call_Ready={10, "Call Ready"};

// ,    ( )
const Message_TypeDef message_Zero_Zero={3, "0,0"};
const Message_TypeDef message_Zero_One={3, "0,1"};
const Message_TypeDef message_Zero_Five={3, "0,5"};

//    
State_Mashine_TypeDef6 const Wait_CallReady_Stage = {6, (void*) &message_Call_Ready, (void*) &message_OK, (void*) &message_PLUS_CREG,
      (void*) &message_Zero_Zero, (void*) &message_Zero_One, (void*) &message_Zero_Five,
                                                      (void*) &Call_Ready, (void*) &Restart_Wait, (void*) &Reg_Reques_Answer,
       (void*) &Digit_ZERO,  (void*) &Digit_ONE,  (void*) &Digit_Five};


void Wait_Net_Registration (void)
{
//    
    SYSTIC_Stop();                                                        // 
//     
    State=1;
    State_Mishine_Copy(State);
    
//    "Call Ready"  
//while (Call_Ready_Flag==0) {}

Net_Registration_Flag=0;

Restart_Wait();

//     SysTic.       Building_String_TX
while (Net_Registration_Flag!=10)
{
}

//    
SYSTIC_Stop();
State=3;  
State_Mishine_Copy(State);
}


void Call_Ready (void)
{
//    
Call_Ready_Flag=1; 
}


void Reg_Reques_Answer(void)
{
//     
  //   :
  //+CREG: 0-2, 0-5

//   ,    ,    Digit_managing
Net_Registration_Flag = 1;
}


void Digit_ZERO(void)
{
  //      : "+CREG:"
if (Net_Registration_Flag==1)
{
  SYSTIC_Stop();
  // ------------------ !!!!!!! -------------------------
  //----------------        --------------
  //--------------     ----------------------------
 
  Restart_Wait();      //     
}
}

void Digit_ONE(void)
{
//-----------------------------------------------
//TIM1->CCR3=0;
//TIM1->CCR3=0;
//-----------------------------------------------
  //      : "+CREG:"
if (Net_Registration_Flag==1)
  Net_Registration_Flag = 9;

}


void Digit_Five(void)
{
  //      : "+CREG:"
if (Net_Registration_Flag==1)
  Net_Registration_Flag = 9;

}


void Restart_Wait(void)
{
SYSTIC_Stop();  
if (Net_Registration_Flag!=9)
{
//    
Built_Read(&Building_String_TX, &message_CREG);

Net_Registration_Flag=0;
Condition_Flag=1;
Echo_Correct_Flag = 1;
Usart_Tx((uint32_t) Building_String_TX.TEXT, Building_String_TX.LEN);

//     SysTic.       Building_String_TX
SYSTIC_Start(WaitTime);
}
else Net_Registration_Flag=10; //  -  

}
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--------------------------           2013         ----------------------------
//------------------------------------------------------------------------------